//+------------------------------------------------------------------+
//|                                                 MyZigZag_d1.mq4  |
//|                                                        auto9817  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "me"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_width1 3
#property indicator_color2 Yellow
#property indicator_width2 3
#property indicator_color3 PapayaWhip
#property indicator_width3 2
#property indicator_color4 Gold
#property indicator_width4 3
#property indicator_color5 Red
#property indicator_width5 3
extern int TimeFrame =3;
extern int Barstodraw=400;


double FractalHigh[10000]; 
double FractalLow[10000];   
double UpFractal[];
double DownFractal[]; 
int  UpFractalPos[10000];
int  DownFractalPos[10000];
double ZigZagH[10000];
double ZigZagL[10000];
double ZigZag[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

SetIndexStyle(0,DRAW_ARROW);
SetIndexBuffer(0,UpFractal);
SetIndexEmptyValue(0,0.0);
SetIndexArrow(0,159);

SetIndexStyle(1,DRAW_ARROW);
SetIndexBuffer(1,DownFractal);
SetIndexEmptyValue(1,0.0);
SetIndexArrow(1,159);

SetIndexStyle(2,DRAW_SECTION);
SetIndexBuffer(2,ZigZag);
SetIndexEmptyValue(2,0.0);


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
 
   int    counted_bars=IndicatorCounted();
   
   if(counted_bars>0)
   counted_bars--;
   
   int limit = Bars-counted_bars;
  
  
  int cnt,FractalNo, c1,c2, c3,c4,c5, p1,p2,p3,p4,p5;
  int UpPos1,UpPos2, UpPos3,UpPos4,UpPos5,LowPos1,LowPos2,LowPos3,LowPos4, LowPos5;
  int gg, FractalCnt=0, OLUpCnt, OLDownCnt;
  double Up1,Up2,Up3,Up4,Up5,Low1,Low2,Low3,Low4,Low5;
  
  
  cnt = Barstodraw;
  
  if(Barstodraw>limit)
  {
  Print("Draw more than available bars (" + limit+ ") is not supported");
  return(0);
  }
  
  
  while(cnt>=0)
  {

      
   
      for(c1=1; c1<=TimeFrame; c1++)
      {
       p1=cnt-c1+1;
       FractalHigh[p1]=High[p1];  
       FractalLow[p1]=Low[p1] ;      
       } 
       
       
       UpPos1=ArrayMaximum(FractalHigh, TimeFrame, p1);
       Up1=FractalHigh[UpPos1];
       
       LowPos1=ArrayMinimum(FractalLow, TimeFrame, p1);
       Low1=FractalLow[LowPos1] ;
         
      
      
      for(c2=1; c2<=TimeFrame; c2++)
      {
       p2=p1-c2;
       FractalHigh[p2]=High[p2];  
       FractalLow[p2]=Low[p2] ;   
       } 
       
       UpPos2=ArrayMaximum(FractalHigh, TimeFrame, p2);
       Up2=FractalHigh[UpPos2];    
       
       LowPos2=ArrayMinimum(FractalLow, TimeFrame, p2);
       Low2=FractalLow[LowPos2] ;
       
       for(c3=1; c3<=TimeFrame; c3++)
       {
       p3=p2-c3;
       FractalHigh[p3]=High[p3];   
       FractalLow[p3]=Low[p3] ;   
       } 
       
       UpPos3=ArrayMaximum(FractalHigh, TimeFrame, p3);
       Up3=FractalHigh[UpPos3];
           
       LowPos3=ArrayMinimum(FractalLow, TimeFrame, p3);
       Low3=FractalLow[LowPos3] ;
       
       
       for(c4=1; c4<=TimeFrame; c4++)
       {
       p4=p3-c4;
       FractalHigh[p4]=High[p4];  
       FractalLow[p4]=Low[p4] ;   
       } 
       
       UpPos4=ArrayMaximum(FractalHigh, TimeFrame, p4);
       Up4=FractalHigh[UpPos4];
       
       LowPos4=ArrayMinimum(FractalLow, TimeFrame, p4);
       Low4=FractalLow[LowPos4] ;
       
       
       for(c5=1; c5<=TimeFrame; c5++)
       {
       p5=p4-c5;
       FractalHigh[p5]=High[p5]; 
       FractalLow[p5]=Low[p5] ;     
       } 
       
       UpPos5=ArrayMaximum(FractalHigh, TimeFrame, p5);
       Up5=FractalHigh[UpPos5];
       
       LowPos5=ArrayMinimum(FractalLow, TimeFrame, p5);
       Low5=FractalLow[LowPos5] ;
       
      OLUpCnt=0;
      OLDownCnt=0;
      
        
       if(Up3>Up1 && Up3>Up2 && Up3>Up4 && Up3>Up5 )       
       {
       UpFractal[UpPos3]=Up3;
       UpFractalPos[FractalCnt]=UpPos3;
       ZigZagH[FractalCnt]=Up3;
       FractalCnt++;
       OLUpCnt = UpPos3;
       } 
       
            
       if(Low3<Low1 &&  Low3<Low2 && Low3<Low4 && Low3<Low5)       
       {
       DownFractal[LowPos3]=Low3;
       DownFractalPos[FractalCnt]=LowPos3;
       ZigZagL[FractalCnt]=Low3;
       FractalCnt++;
       OLDownCnt=LowPos3; 
         
        
             if(OLDownCnt==OLUpCnt)
             {
                      if(Close[OLDownCnt]>Open[OLUpCnt])
                      {                      
                      ZigZagL[FractalCnt-1]=0;
                      FractalCnt--;
                      }
                      
                      if(Close[OLDownCnt]<Open[OLUpCnt])
                      {                      
                   
                      ZigZagH[FractalCnt-2]=0;
                      ZigZagL[FractalCnt-1]=0;   
                      ZigZagL[FractalCnt-2]=Low3;
                      FractalCnt--;
                      }       
             }    
             
            //Block100: (this block removes  
          if(OLUpCnt>0 && OLDownCnt>0 &&OLDownCnt>OLUpCnt && TimeFrame>1)
            {
                             
                      ZigZagL[FractalCnt-1]=0; 
                      FractalCnt--;
            }    
            //Block100 ends
            
          /* important  , this multiTime Frame ZigZag had one odd problems which was not able to fix. Below code is counter part of block 100 but it does not work together. Recommendation is not to use time scale greater than 3. later the problem to be fixed    
          /* if(OLUpCnt>0 && OLDownCnt>0 && OLUpCnt>OLDownCnt && TimeFrame>1)
             {
                      
                      ZigZagH[FractalCnt-2]=0;
                      ZigZagL[FractalCnt-1]=0;   
                      ZigZagL[FractalCnt-2]=Low3;
                      FractalCnt--;
      
              }  */
              
                                                 
       }   
       
       cnt=cnt-TimeFrame;
      
      }
      
     // Fractal ends --------------+
     

    //Zigzag starts---------------+
      
   for(int HCnt = 0; HCnt<= FractalCnt; HCnt++)
   {
   
        if(ZigZagH[HCnt]>0 && ZigZagH[HCnt-1]>0)
        {
         int SHS=HCnt-1;
    
              for(int SHCnt =SHS; SHCnt<=FractalCnt; SHCnt++)  // SHCnt = Successive High counter
              {
           
                 if(ZigZagH[SHCnt]==0)
                 {
               // SHE= Last Successive High end
                 int SHE=SHCnt-1; 
                 break;
                 }
                
              } 
  
        HCnt=SHCnt;
    
        int HighPos=ArrayMaximum(ZigZagH, SHE-SHS+1, SHS);
        double HighVal=ZigZagH[HighPos];
      
              for (int DHCnt=SHS;DHCnt<=SHE;DHCnt++)  // DHCnt == delete hgih counter
               {
               ZigZagH[DHCnt]=0;
               }
     
       ZigZagH[HighPos]=HighVal;
    
    
       }
   
   }
   
 
     for(int LCnt = 0; LCnt<= FractalCnt; LCnt++)
     {
   
          if(ZigZagL[LCnt]>0 && ZigZagL[LCnt-1]>0)
          {
           int SLS=LCnt-1;
   
               for(int SLCnt =SLS; SLCnt<=FractalCnt; SLCnt++)
               {
     
                      if(ZigZagL[SLCnt]==0)
                      {  
                      int SLE=SLCnt-1;   // SLNo = Successive Low number               
                      break;
                      }     
            
               } 

       
          
           int LowPos=ArrayMinimum(ZigZagL, SLE-SLS+1, SLS);
           double LowVal=ZigZagL[LowPos];
      
               for (int DLCnt=SLS;DLCnt<=SLE;DLCnt++)
               {
               ZigZagL[DLCnt]=0;
               }
     
           ZigZagL[LowPos]=LowVal;
  
           LCnt=SLCnt;
            
          }
          
        
   
     }
   
 
  
        
  //putting high and low fractal points to ZigZag[] array
  
  for(int ZCnt=0;ZCnt<=FractalCnt;ZCnt++)
  {
  
       if(ZigZagH[ZCnt]>0)
       {
       ZigZag[UpFractalPos[ZCnt]]=ZigZagH[ZCnt];
       }
  
       if(ZigZagL[ZCnt]>0)
       {
       ZigZag[DownFractalPos[ZCnt]]=ZigZagL[ZCnt];
        }
      
  }
   
        
  //zigzag ends---------------+   
        
   return(0);
  }
  
//+------------------------------------------------------------------+